<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<title>Introduction</title>
</head>

<body>

<h1 align=center>MIP: Introduction</h1>

<p>MIP is My Image-processing Plug-in. It can be used both for end user as a
tool and for developer as a code base for further development.&nbsp;</p>
<ul>
  <li><a href="#goal">Goal</a></li>
  <li><a href="#gui">GUI</a></li>
  <li><a href="#perspective">Perspective</a>
    <ul>
      <li><a href="#imageView">Image V iew</a></li>
      <li><a href="#histogramView">Histogram View</a></li>
      <li><a href="#thumbView">Thumb View</a></li>
      <li><a href="#toolkitPanel">Toolkit Panel</a></li>
    </ul>
  </li>
  <li><a href="#control">Controls</a>
    <ul>
      <li><a href="#tkPanelBtn">Toolkit Panel button</a></li>
      <li><a href="#toolbarBtn">View toolbar button</a></li>
    </ul>
  </li>
  <li><a href="#menu">Menu</a>
    <ul>
      <li><a href="#localMenu">Image View local menu</a></li>
      <li><a href="#contextMenu">Image View context menu</a></li>
      <li><a href="#naviPopup">Navigator popup menu</a></li>
    </ul>
  </li>
  <li><a href="#dialog">Dialog</a>
    <ul>
      <li><a href="#contrastDlg">Contrast dialog</a></li>
      <li><a href="#thresholdDlg">Threshold dialog</a></li>
    </ul>
  </li>
  <li><a href="#statusBar">Status bar</a></li>
  <li><a href="#keyShortcut">Key shortcut supporting</a></li>
</ul>
<h1><a name="goal"></a>Goal</h1>
<p>The idea to develop MIP is triggered partly by some sparks in my mind when I
tried to finish my master project, the project was to compare the performance of
JNI (Java Native Interface, not included in this version plug-in) and pure Java
on Eclipse. At that time, I used some Image processing algorithm to test the
speed. Though the final results shown that the JNI performance was not as good
as expected, I did like Eclipse.&nbsp;</p>
<p>Eclipse triggered me greatly to develop a plug-in which can not only be used as a
tool for research and teaching for end users, but also provide a basic workbench
for Image processing&nbsp; scientists, so that they can easily attach their own algorithm to it, or at least provide some basic examples for showing how to use
imaging function of Eclipse to implement imaging tool. If any of these efforts
has been recognized, or this plug-in trigger your interest in image on Eclipse, I
would be very happy.</p>
<p>MIP takes a lot of advantages of Eclipse, and it provides extension points for
future user to use, for example, user can provide his own image loader to load
image format which is not currently supported by Eclipse, he also can add his
own algorithm and add a corresponding GUI component to the plug-in easily. All
the common GUI like context menu, local toolbar and menu are all continue to
provide extension point to developers. Most of important, everything can be
configured by using <i>plugin.xml</i> and the <i>plugin.properties</i> file.</p>
<p>MIP design uses multi-level structure. Each higher level design is based on
the better tested lower level classes, so it reduces the debug time. The plug-in
provides full access to its inner data structure.</p>
<p>MIP currently implemented as View, however, since I use multilevel structure,
the core imaging class has no relation with View, so you can easily convert it to Editor.</p>
<p>Also, MIP provides a friendly user interface. I have referred to the GUI of
PhotoShop, and tried to make the interface friendly. You may see some operations
are pretty familiar if you used PhotoShop before.</p>
<p>However, the develop period is fairly short. I did not test too much and I hope
it can work well. Thanks for letting me know any bug.&nbsp;</p>
<p>I also tried hard to well document this plug-in, again, due to time, I could
not check it thoroughly, if you have any question about this code, please
contact Chengdong Li at <a href="mailto:%20cdli@ccs.uky.edu">cdli@ccs.uky.edu</a>.&nbsp;</p>
<h1><a name="gui"></a>GUI</h1>
<p>The MIP plug-in is used for basic graphics 2D manipulation and image processing
operation. It is a perspective which contains three views:</p>
<ul>
  <li>Thumb view</li>
  <li>Intensity histogram view</li>
  <li>Image view</li>
</ul>
<p>It supports graphics 2D operations:</p>
<ul>
  <li>Zoom in/out</li>
  <li>Translation</li>
</ul>
It also supports basic image processing algorithm:
<ul>
  <li>Convolution based space filter: Guassian filter, sharpen, blur, edge
    detection, thresholding</li>
  <li>Image enhancement: Contrast and brightness adjustment</li>
</ul>
Here is the snapshot of the MIP plug-in. <br><p align="center"><img border="0" src="images/overview1.jpg" width="640" height="503"></p>

<h2><a name="perspective"></a>Image perspective</h2>
<p >In the above figure, the top window with circled title is
for MIP perspective, this perspective includes three image-related
views, a toolkit panel and a navigator view from Eclipse. The three circled views from left to
right, top to bottom are: <i>Thumb view</i>, <i>Histogram view</i> and <i>Image
view</i>. The <i>toolkit panel</i> can be hide/show by using TAB key. ESC key
can dispose it.</p>


<h3><a name="imageView"></a>Image View</h3>
<p >Image view is used to manipulate and process the image, it
also shows the result after each operation. It has several toolbar buttons and a
pull down menu. The toolbar buttons are used to open and save image files;
redo/undo operations. The menu bar is used for image processing. You may further
add your own image processing algorithm here.
</p>


<h3><a name="thumbView"></a>Thumb View</h3>
<p >Thumb view is useful when you try to process a big image
with a small screen space. In this case, you can see the whole image by choosing
the thumb view. The <i>slider</i> (red rectangle) will show the image in the
current Image View window. You can move it to navigate the image. Thumb view will show you a scaled whole
image which is very helpful for navigating.

<h3><a name="histogramView"></a>Histogram View</h3>
<p >Histogram view is used for showing intensity of histogram
for each different color channel and luminosity. This is useful for evaluating
your image operation, for example, when you try to adjust the contrast of your
image, you may try to find a good parameter by studying the histogram of the
processed image.</p>


<h3><a name="toolkitPanel"></a>Toolkit panel</h3>
<p >Toolkit panel is used for choose tools for image processing. There are
selection tool which show ant row rectangle; the eye-drop may be used to choose
different color; the pencil will draw and fill image. Currently, the tools in
this panel is enough for manual image correction plus the image processing
methods in the menu bar.
</p>

<p >In fact, we can add the tool button on the local toolbar of view on Eclipse.
Considering scalable, I design a toolkit panel to hold all toolkit, and
developer can add their own tool into this panel by changing plugin.xml.
</p>

<p >Toolkit panel also have several other useful tools like zoom and lenses.&nbsp;
</p>

<h2 ><a name="control"></a>Control
</h2>

<h3 ><a name="tkPanelBtn"></a>Toolkit panel buttons:
</h3>

<p ><img border="0" src="images/toolkit.jpg" width="52" height="172">
</p>

<ul>
  <li><img border="0" src="images/Select16.gif" width="16" height="16">:
select the sub-area which you want to process. You can process the selected
image sub-image without changing other area, also for drawing.</li>
  <li><img border="0" src="images/Eyedrop16.gif" width="16" height="16">: select
    the foreground color from screen image.</li>
  <li><img border="0" src="images/Pencil16.gif" width="16" height="16">: draw
    point or fill rectangle when zooming larger. It is not a continuous drawing
    tool, but if you draw slow, you can get continuouse effect.</li>
  <li><img border="0" src="images/Lense16.gif" width="16" height="16">:
toolkit like a zoom lense. You can change the zoom rate of the lense by press
keyboard 1~9, and change the size of the lense by ctrl+mouse.</li>
  <li><img border="0" src="images/ZoomIn16.gif" width="16" height="16">:
zoom in the current image.</li>
  <li><img border="0" src="images/ZoomOut16.gif" width="16" height="16">:
zoom out the current image.</li>
  <li><img border="0" src="images/Move16.gif" width="16" height="16">:
move the current image. You can also move image by holding white space and move
the mouse.</li>
  <li><img border="0" src="images/pallete.jpg" width="45" height="45">: choose
    fore/background color using color pallette. The top-right color can be
    clicked to switch fore/background color. The bottom-left color can be
    clicked to restore to black/white color.</li>
</ul>
<p >&nbsp;
</p>

<h3 ><a name="toolbarBtn"></a>Toolbar buttons:
</h3>

<p align="left" ><img border="0" src="images/toolbar.jpg" width="120" height="22">
</p>

<ul>
  <li><img border="0" src="images/Open16.gif" width="16" height="16">:
open an image file, support all image format for Eclipse 2.1.1.</li>
  <li><img border="0" src="images/Save16.gif" width="16" height="16">:
save the image into a file, currently we support bmp only, since it is the most
    stable one.</li>
  <li><img border="0" src="images/Undo16.gif" width="16" height="16">:
undo last operation.</li>
  <li><img border="0" src="images/Redo16.gif" width="16" height="16">:
redo last operation.</li>
  <li><img border="0" src="images/Help16.gif" width="16" height="16">:
help topic for this plug-in.</li>
</ul>
<h3 ><a name="menu"></a>Menus:
</h3>

<h4 ><a name="localMenu"></a>local menubar:
</h4>

<p align="left" ><img border="0" src="images/menu.jpg" width="234" height="145">
</p>

<ul>
  <li>Equalization: equalize the current image( or selected
sub-image) using uniform non adaptive histogram equalization method.</li>
  <li>Contrast/Bright: change the contrast and brightness of the
current image( or selected sub-image) using linear transform method. This will
bring up a dialog.</li>
  <li>Threshold: change the color used in showing the current
image( or selected sub-image) using threshold method. This will bring up a
dialog.</li>
  <li>Native call: a check-box menuitem, which will enable the
native call for processing when checked. The native call only available for some
computation intensive algorithm such as convolution.</li>
  <li>Convolution/Gauss7: Gaussian filtering with 7x7 kernel.</li>
  <li>Convolution/edge detect: convolution based edge detection</li>
  <li>Convolution/sharpen: convolution based sharpening.</li>
  <li>Convolution/blur: convolution based blur.</li>
</ul>
<h4 ><a name="contextMenu"></a>Context menu:
</h4>

<p >Context menu is provided for Image View:
</p>

<p ><img border="0" src="images/context_mnu.jpg" width="140" height="121">
</p>

<ul>
  <li><img border="0" src="images/Center16.gif" width="16" height="16">: move
    the selection to the center of Image View. This is enabled only if you have
    selected some area.</li>
  <li><img border="0" src="images/Content16.gif" width="16" height="16">:
fit the image into the current window.</li>
  <li><img border="0" src="images/Fitv16.gif" width="16" height="16">:
fit current window vertically.</li>
  <li><img border="0" src="images/Fith16.gif" width="16" height="16">:
fit current window horizontally.</li>
  <li><img border="0" src="images/Normal16.gif" width="16" height="16">:
show image as the original size.</li>
</ul>

<h4 ><a name="naviPopup"></a>Navigator view popup:
</h4>

<p >You can also open an image in workspace by right licking the
mouse button, and select &quot;<b>processing</b>&quot; from the context menu in
navigator view:
</p>

<p align="center" ><img border="0" src="images/context_nav.jpg" width="209" height="576">
</p>

<h3 ><a name="dialog"></a>Dialogs:
</h3>

<h4 ><a name="thresholdDlg"></a>Threshold Dialog:
</h4>

<p >You can change the color used in showing the current image(
or selected sub-image) by using the threshold dialog. This dialog will be
invoked by choosing <b>menu-&gt;threshold</b>. The three sliders on the dialog
will change the threshold for each color channel. Each color under the threshold
will be dark (0), and each color above the threshold will be white (255).
</p>

<p align="center" ><img border="0" src="images/threshold_dlg.jpg" width="474" height="340">
</p>

<h4 ><a name="contrastDlg"></a>Contrast/brightness Dialog:
</h4>

<p >You can change the contrast and brightness of the current
image( or selected sub-image) by using the contrast/brightness dialog. This
dialog will be invoked by choosing <b>menu-&gt;Contrast/Bright</b>. The two
sliders on the dialog will change the contrast and brightness for the selected
area. The contrast ranges from 0~10, and brightness ranges from -255~255.
</p>

<p align="center" ><img border="0" src="images/contrast_dlg.jpg" width="433" height="316">
</p>

<p >&nbsp;</p>
<h3 ><a name="statusBar"></a>Status bar:
</h3>

<p >The status bar under the bottom of Image view is used to :
Show the prompt information for current operation; show the processing progress;
show processing time; show color information of pixel under the current mouse
position; show mouse position.
</p>

<p align="center" ><img border="0" src="images/status_bar.jpg" width="640" height="17"></p>
<h2 align="left"><a name="keyShortcut"></a>Key shortcut supporting</h2>
<ul>
  <li>
    <p align="left">TAB: show/hide the toolkit panel.</li>
  <li>
    <p align="left">ESC: when toolkit panel gets focus, it will dispose toolkit
    panel.</li>
  <li>
    <p align="left">Ctrl+O: open image file.</li>
  <li>
    <p align="left">S: save image file.</li>
  <li>
    <p align="left">Ctrl+Z: undo image processing algorithm</li>
  <li>
    <p align="left">Ctrl+Y: redo image processing algorithm</li>
  <li>
    <p align="left">HOME: move the image to the head of line.</li>
  <li>
    <p align="left">END: move image to the line end.</li>
  <li>
    <p align="left">Ctrl+HOME: move image to top left.</li>
  <li>
    <p align="left">Ctrl+END: move image to the bottom right.</li>
  <li>
    <p align="left">PageUP: move backward one page.</li>
  <li>
    <p align="left">PageDown: move forward one page.</li>
  <li>
    <p align="left">ArrowUP: move backward one step.</li>
  <li>
    <p align="left">ArrowDown: move forward one step.</li>
  <li>
    <p align="left">ArrowLeft: move left one step.</li>
  <li>
    <p align="left">ArrowRight: move right one step.</li>
  <li>
    <p align="left">+: zoom in.</li>
  <li>
    <p align="left">-: zoom out.</li>
  <li>
    <p align="left">0: show original size.</li>
  <li>
    <p align="left">SPACE+MOUSE: move image in any session.</li>
</ul>
<h3 align="left">Lense session:</h3>
<ul>
  <li>
    <p align="left">Ctrl+MOUSE: change lense size in lense session.</li>
  <li>
    <p align="left">2: change lense zoom rate to 2 in lense.</li>
  <li>
    <p align="left">3: change lense zoom rate to 3.</li>
  <li>
    <p align="left">4: change lense zoom rate to 4.</li>
</ul>
<h3 align="left">Select session:</h3>
<ul>
  <li>
    <p align="left">ESC: cancel current selection;</li>
</ul>
<h3 align="left">Pencil session:</h3>
<ul>
  <li>
    <p align="left">ESC: cancel last drawing.</li>
</ul>
<p align="left"><font color="#FF0000" size="5"><b>To use MIP, you must accept
Common Public License (CPL).</b></font></p>
<p align="left">-Chengdong <br>
&nbsp;</p>
<p align="left">&nbsp;</p>
<p align="left">&nbsp;</p>
</body>
</html>